Package org.apache.commons.io

# Class IOUtils

java.lang.Object
org.apache.commons.io.IOUtils

public class IOUtils extends Object
General IO stream manipulation utilities.

This class provides static utility methods for input/output operations.

- closeQuietly - these methods close a stream ignoring nulls and exceptions
- toXxx/read - these methods read data from a stream
- write - these methods write data to a stream
- copy - these methods copy all the data from one stream to another
- contentEquals - these methods compare the content of two streams

The byte-to-char methods and char-to-byte methods involve a conversion step. Two methods are provided in each case, one that uses the platform default encoding and the other which allows you to specify an encoding. You are encouraged to always specify an encoding because relying on the platform default can lead to unexpected results, for example when moving from development to production.

All the methods in this class that read a stream are buffered internally. This means that there is no cause to use a `BufferedInputStream` or `BufferedReader`. The default buffer size of 4K has been shown to be efficient in tests.

The various copy methods all delegate the actual copying to one of the following methods:

- `copyLarge(InputStream, OutputStream, byte[])`
- `copyLarge(InputStream, OutputStream, long, long, byte[])`
- `copyLarge(Reader, Writer, char[])`
- `copyLarge(Reader, Writer, long, long, char[])`

For example, `copy(InputStream, OutputStream)` calls `copyLarge(InputStream, OutputStream)` which calls `copy(InputStream, OutputStream, int)` which creates the buffer and calls `copyLarge(InputStream, OutputStream, byte[])`.

Applications can re-use buffers by using the underlying methods directly. This may improve performance for applications that need to do a lot of copying.

Wherever possible, the methods in this class do not flush or close the stream. This is to avoid making non-portable assumptions about the streams' origin and further use. Thus the caller is still responsible for closing streams after use.

Provenance: Excalibur.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `CR`
  CR char.
  `static final int`
  `DEFAULT_BUFFER_SIZE`
  The default buffer size (8192) to use in copy methods.
  `static final char`
  `DIR_SEPARATOR`
  The system directory separator character.
  `static final char`
  `DIR_SEPARATOR_UNIX`
  The Unix directory separator character.
  `static final char`
  `DIR_SEPARATOR_WINDOWS`
  The Windows directory separator character.
  `static final byte[]`
  `EMPTY_BYTE_ARRAY`
  A singleton empty byte array.
  `static final int`
  `EOF`
  Represents the end-of-file (or stream).
  `static final int`
  `LF`
  LF char.
  `static final String`
  `LINE_SEPARATOR`
  Deprecated.
  Use `System.lineSeparator()`.
  `static final String`
  `LINE_SEPARATOR_UNIX`
  The Unix line separator string.
  `static final String`
  `LINE_SEPARATOR_WINDOWS`
  The Windows line separator string.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IOUtils()`
  Deprecated.
  Will be private in 3.0.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static BufferedInputStream`
  `buffer(InputStream inputStream)`
  Returns the given InputStream if it is already a `BufferedInputStream`, otherwise creates a BufferedInputStream from the given InputStream.
  `static BufferedInputStream`
  `buffer(InputStream inputStream, int size)`
  Returns the given InputStream if it is already a `BufferedInputStream`, otherwise creates a BufferedInputStream from the given InputStream.
  `static BufferedOutputStream`
  `buffer(OutputStream outputStream)`
  Returns the given OutputStream if it is already a `BufferedOutputStream`, otherwise creates a BufferedOutputStream from the given OutputStream.
  `static BufferedOutputStream`
  `buffer(OutputStream outputStream, int size)`
  Returns the given OutputStream if it is already a `BufferedOutputStream`, otherwise creates a BufferedOutputStream from the given OutputStream.
  `static BufferedReader`
  `buffer(Reader reader)`
  Returns the given reader if it is already a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
  `static BufferedReader`
  `buffer(Reader reader, int size)`
  Returns the given reader if it is already a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
  `static BufferedWriter`
  `buffer(Writer writer)`
  Returns the given Writer if it is already a `BufferedWriter`, otherwise creates a BufferedWriter from the given Writer.
  `static BufferedWriter`
  `buffer(Writer writer, int size)`
  Returns the given Writer if it is already a `BufferedWriter`, otherwise creates a BufferedWriter from the given Writer.
  `static byte[]`
  `byteArray()`
  Returns a new byte array of size `DEFAULT_BUFFER_SIZE`.
  `static byte[]`
  `byteArray(int size)`
  Returns a new byte array of the given size.
  `static void`
  `close(Closeable closeable)`
  Closes the given `Closeable` as a null-safe operation.
  `static void`
  `close(Closeable... closeables)`
  Closes the given `Closeable`s as null-safe operations.
  `static void`
  `close(Closeable closeable, IOConsumer<IOException> consumer)`
  Closes the given `Closeable` as a null-safe operation.
  `static void`
  `close(URLConnection conn)`
  Closes a URLConnection.
  `static void`
  `closeQuietly(Closeable closeable)`
  Closes a `Closeable` unconditionally.
  `static void`
  `closeQuietly(Closeable... closeables)`
  Closes a `Closeable` unconditionally.
  `static void`
  `closeQuietly(Closeable closeable, Consumer<IOException> consumer)`
  Closes the given `Closeable` as a null-safe operation while consuming IOException by the given `consumer`.
  `static void`
  `closeQuietly(InputStream input)`
  Closes an `InputStream` unconditionally.
  `static void`
  `closeQuietly(OutputStream output)`
  Closes an `OutputStream` unconditionally.
  `static void`
  `closeQuietly(Reader reader)`
  Closes an `Reader` unconditionally.
  `static void`
  `closeQuietly(Writer writer)`
  Closes an `Writer` unconditionally.
  `static void`
  `closeQuietly(Iterable<Closeable> closeables)`
  Closes an iterable of `Closeable` unconditionally.
  `static void`
  `closeQuietly(ServerSocket serverSocket)`
  Closes a `ServerSocket` unconditionally.
  `static void`
  `closeQuietly(Socket socket)`
  Closes a `Socket` unconditionally.
  `static void`
  `closeQuietly(Selector selector)`
  Closes a `Selector` unconditionally.
  `static void`
  `closeQuietly(Stream<Closeable> closeables)`
  Closes a stream of `Closeable` unconditionally.
  `static long`
  `consume(InputStream input)`
  Consumes bytes from a `InputStream` and ignores them.
  `static long`
  `consume(Reader input)`
  Consumes characters from a `Reader` and ignores them.
  `static boolean`
  `contentEquals(InputStream input1, InputStream input2)`
  Compares the contents of two Streams to determine if they are equal or not.
  `static boolean`
  `contentEquals(Reader input1, Reader input2)`
  Compares the contents of two Readers to determine if they are equal or not.
  `static boolean`
  `contentEqualsIgnoreEOL(Reader reader1, Reader reader2)`
  Compares the contents of two Readers to determine if they are equal or not, ignoring EOL characters.
  `static QueueInputStream`
  `copy(ByteArrayOutputStream outputStream)`
  Copies bytes from a `ByteArrayOutputStream` to a `QueueInputStream`.
  `static int`
  `copy(InputStream inputStream, OutputStream outputStream)`
  Copies bytes from an `InputStream` to an `OutputStream`.
  `static long`
  `copy(InputStream inputStream, OutputStream outputStream, int bufferSize)`
  Copies bytes from an `InputStream` to an `OutputStream` using an internal buffer of the given size.
  `static void`
  `copy(InputStream input, Writer writer)`
  Deprecated.
  2.5 use `copy(InputStream, Writer, Charset)` instead
  `static void`
  `copy(InputStream input, Writer writer, String inputCharsetName)`
  Copies bytes from an `InputStream` to chars on a `Writer` using the specified character encoding.
  `static void`
  `copy(InputStream input, Writer writer, Charset inputCharset)`
  Copies bytes from an `InputStream` to chars on a `Writer` using the specified character encoding.
  `static void`
  `copy(Reader reader, OutputStream output)`
  Deprecated.
  2.5 use `copy(Reader, OutputStream, Charset)` instead
  `static void`
  `copy(Reader reader, OutputStream output, String outputCharsetName)`
  Copies chars from a `Reader` to bytes on an `OutputStream` using the specified character encoding, and calling flush.
  `static void`
  `copy(Reader reader, OutputStream output, Charset outputCharset)`
  Copies chars from a `Reader` to bytes on an `OutputStream` using the specified character encoding, and calling flush.
  `static int`
  `copy(Reader reader, Writer writer)`
  Copies chars from a `Reader` to a `Writer`.
  `static long`
  `copy(Reader reader, Appendable output)`
  Copies chars from a `Reader` to a `Appendable`.
  `static long`
  `copy(Reader reader, Appendable output, CharBuffer buffer)`
  Copies chars from a `Reader` to an `Appendable`.
  `static long`
  `copy(URL url, File file)`
  Copies bytes from a `URL` to an `OutputStream`.
  `static long`
  `copy(URL url, OutputStream outputStream)`
  Copies bytes from a `URL` to an `OutputStream`.
  `static long`
  `copyLarge(InputStream inputStream, OutputStream outputStream)`
  Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.
  `static long`
  `copyLarge(InputStream inputStream, OutputStream outputStream, byte[] buffer)`
  Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.
  `static long`
  `copyLarge(InputStream input, OutputStream output, long inputOffset, long length)`
  Copies some or all bytes from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input bytes.
  `static long`
  `copyLarge(InputStream input, OutputStream output, long inputOffset, long length, byte[] buffer)`
  Copies some or all bytes from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input bytes.
  `static long`
  `copyLarge(Reader reader, Writer writer)`
  Copies chars from a large (over 2GB) `Reader` to a `Writer`.
  `static long`
  `copyLarge(Reader reader, Writer writer, char[] buffer)`
  Copies chars from a large (over 2GB) `Reader` to a `Writer`.
  `static long`
  `copyLarge(Reader reader, Writer writer, long inputOffset, long length)`
  Copies some or all chars from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input chars.
  `static long`
  `copyLarge(Reader reader, Writer writer, long inputOffset, long length, char[] buffer)`
  Copies some or all chars from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input chars.
  `static int`
  `length(byte[] array)`
  Returns the length of the given array in a null-safe manner.
  `static int`
  `length(char[] array)`
  Returns the length of the given array in a null-safe manner.
  `static int`
  `length(CharSequence csq)`
  Returns the length of the given CharSequence in a null-safe manner.
  `static int`
  `length(Object[] array)`
  Returns the length of the given array in a null-safe manner.
  `static LineIterator`
  `lineIterator(InputStream input, String charsetName)`
  Returns an Iterator for the lines in an `InputStream`, using the character encoding specified (or default encoding if null).
  `static LineIterator`
  `lineIterator(InputStream input, Charset charset)`
  Returns an Iterator for the lines in an `InputStream`, using the character encoding specified (or default encoding if null).
  `static LineIterator`
  `lineIterator(Reader reader)`
  Returns an Iterator for the lines in a `Reader`.
  `static int`
  `read(InputStream input, byte[] buffer)`
  Reads bytes from an input stream.
  `static int`
  `read(InputStream input, byte[] buffer, int offset, int length)`
  Reads bytes from an input stream.
  `static int`
  `read(Reader reader, char[] buffer)`
  Reads characters from an input character stream.
  `static int`
  `read(Reader reader, char[] buffer, int offset, int length)`
  Reads characters from an input character stream.
  `static int`
  `read(ReadableByteChannel input, ByteBuffer buffer)`
  Reads bytes from a ReadableByteChannel.
  `static void`
  `readFully(InputStream input, byte[] buffer)`
  Reads the requested number of bytes or fail if there are not enough left.
  `static void`
  `readFully(InputStream input, byte[] buffer, int offset, int length)`
  Reads the requested number of bytes or fail if there are not enough left.
  `static byte[]`
  `readFully(InputStream input, int length)`
  Reads the requested number of bytes or fail if there are not enough left.
  `static void`
  `readFully(Reader reader, char[] buffer)`
  Reads the requested number of characters or fail if there are not enough left.
  `static void`
  `readFully(Reader reader, char[] buffer, int offset, int length)`
  Reads the requested number of characters or fail if there are not enough left.
  `static void`
  `readFully(ReadableByteChannel input, ByteBuffer buffer)`
  Reads the requested number of bytes or fail if there are not enough left.
  `static List<String>`
  `readLines(InputStream input)`
  Deprecated.
  2.5 use `readLines(InputStream, Charset)` instead
  `static List<String>`
  `readLines(InputStream input, String charsetName)`
  Gets the contents of an `InputStream` as a list of Strings, one entry per line, using the specified character encoding.
  `static List<String>`
  `readLines(InputStream input, Charset charset)`
  Gets the contents of an `InputStream` as a list of Strings, one entry per line, using the specified character encoding.
  `static List<String>`
  `readLines(Reader reader)`
  Gets the contents of a `Reader` as a list of Strings, one entry per line.
  `static byte[]`
  `resourceToByteArray(String name)`
  Gets the contents of a resource as a byte array.
  `static byte[]`
  `resourceToByteArray(String name, ClassLoader classLoader)`
  Gets the contents of a resource as a byte array.
  `static String`
  `resourceToString(String name, Charset charset)`
  Gets the contents of a resource as a String using the specified character encoding.
  `static String`
  `resourceToString(String name, Charset charset, ClassLoader classLoader)`
  Gets the contents of a resource as a String using the specified character encoding.
  `static URL`
  `resourceToURL(String name)`
  Gets a URL pointing to the given resource.
  `static URL`
  `resourceToURL(String name, ClassLoader classLoader)`
  Gets a URL pointing to the given resource.
  `static long`
  `skip(InputStream input, long toSkip)`
  Skips bytes from an input byte stream.
  `static long`
  `skip(InputStream input, long toSkip, Supplier<byte[]> skipBufferSupplier)`
  Skips bytes from an input byte stream.
  `static long`
  `skip(Reader reader, long toSkip)`
  Skips characters from an input character stream.
  `static long`
  `skip(ReadableByteChannel input, long toSkip)`
  Skips bytes from a ReadableByteChannel.
  `static void`
  `skipFully(InputStream input, long toSkip)`
  Skips the requested number of bytes or fail if there are not enough left.
  `static void`
  `skipFully(InputStream input, long toSkip, Supplier<byte[]> skipBufferSupplier)`
  Skips the requested number of bytes or fail if there are not enough left.
  `static void`
  `skipFully(Reader reader, long toSkip)`
  Skips the requested number of characters or fail if there are not enough left.
  `static void`
  `skipFully(ReadableByteChannel input, long toSkip)`
  Skips the requested number of bytes or fail if there are not enough left.
  `static InputStream`
  `toBufferedInputStream(InputStream input)`
  Fetches entire contents of an `InputStream` and represent same data as result InputStream.
  `static InputStream`
  `toBufferedInputStream(InputStream input, int size)`
  Fetches entire contents of an `InputStream` and represent same data as result InputStream.
  `static BufferedReader`
  `toBufferedReader(Reader reader)`
  Returns the given reader if it is a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
  `static BufferedReader`
  `toBufferedReader(Reader reader, int size)`
  Returns the given reader if it is a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
  `static byte[]`
  `toByteArray(InputStream inputStream)`
  Gets the contents of an `InputStream` as a `byte[]`.
  `static byte[]`
  `toByteArray(InputStream input, int size)`
  Gets the contents of an `InputStream` as a `byte[]`.
  `static byte[]`
  `toByteArray(InputStream input, long size)`
  Gets contents of an `InputStream` as a `byte[]`.
  `static byte[]`
  `toByteArray(Reader reader)`
  Deprecated.
  2.5 use `toByteArray(Reader, Charset)` instead
  `static byte[]`
  `toByteArray(Reader reader, String charsetName)`
  Gets the contents of a `Reader` as a `byte[]` using the specified character encoding.
  `static byte[]`
  `toByteArray(Reader reader, Charset charset)`
  Gets the contents of a `Reader` as a `byte[]` using the specified character encoding.
  `static byte[]`
  `toByteArray(String input)`
  Deprecated.
  2.5 Use `String.getBytes()` instead
  `static byte[]`
  `toByteArray(URI uri)`
  Gets the contents of a `URI` as a `byte[]`.
  `static byte[]`
  `toByteArray(URL url)`
  Gets the contents of a `URL` as a `byte[]`.
  `static byte[]`
  `toByteArray(URLConnection urlConnection)`
  Gets the contents of a `URLConnection` as a `byte[]`.
  `static char[]`
  `toCharArray(InputStream inputStream)`
  Deprecated.
  2.5 use `toCharArray(InputStream, Charset)` instead
  `static char[]`
  `toCharArray(InputStream inputStream, String charsetName)`
  Gets the contents of an `InputStream` as a character array using the specified character encoding.
  `static char[]`
  `toCharArray(InputStream inputStream, Charset charset)`
  Gets the contents of an `InputStream` as a character array using the specified character encoding.
  `static char[]`
  `toCharArray(Reader reader)`
  Gets the contents of a `Reader` as a character array.
  `static InputStream`
  `toInputStream(CharSequence input)`
  Deprecated.
  2.5 use `toInputStream(CharSequence, Charset)` instead
  `static InputStream`
  `toInputStream(CharSequence input, String charsetName)`
  Converts the specified CharSequence to an input stream, encoded as bytes using the specified character encoding.
  `static InputStream`
  `toInputStream(CharSequence input, Charset charset)`
  Converts the specified CharSequence to an input stream, encoded as bytes using the specified character encoding.
  `static InputStream`
  `toInputStream(String input)`
  Deprecated.
  2.5 use `toInputStream(String, Charset)` instead
  `static InputStream`
  `toInputStream(String input, String charsetName)`
  Converts the specified string to an input stream, encoded as bytes using the specified character encoding.
  `static InputStream`
  `toInputStream(String input, Charset charset)`
  Converts the specified string to an input stream, encoded as bytes using the specified character encoding.
  `static String`
  `toString(byte[] input)`
  Deprecated.
  2.5 Use `String(byte[])` instead
  `static String`
  `toString(byte[] input, String charsetName)`
  Gets the contents of a `byte[]` as a String using the specified character encoding.
  `static String`
  `toString(InputStream input)`
  Deprecated.
  2.5 use `toString(InputStream, Charset)` instead
  `static String`
  `toString(InputStream input, String charsetName)`
  Gets the contents of an `InputStream` as a String using the specified character encoding.
  `static String`
  `toString(InputStream input, Charset charset)`
  Gets the contents of an `InputStream` as a String using the specified character encoding.
  `static String`
  `toString(Reader reader)`
  Gets the contents of a `Reader` as a String.
  `static String`
  `toString(URI uri)`
  Deprecated.
  2.5 use `toString(URI, Charset)` instead
  `static String`
  `toString(URI uri, String charsetName)`
  Gets the contents at the given URI.
  `static String`
  `toString(URI uri, Charset encoding)`
  Gets the contents at the given URI.
  `static String`
  `toString(URL url)`
  Deprecated.
  2.5 use `toString(URL, Charset)` instead
  `static String`
  `toString(URL url, String charsetName)`
  Gets the contents at the given URL.
  `static String`
  `toString(URL url, Charset encoding)`
  Gets the contents at the given URL.
  `static String`
  `toString(IOSupplier<InputStream> input, Charset charset)`
  Gets the contents of an `InputStream` from a supplier as a String using the specified character encoding.
  `static String`
  `toString(IOSupplier<InputStream> input, Charset charset, IOSupplier<String> defaultString)`
  Gets the contents of an `InputStream` from a supplier as a String using the specified character encoding.
  `static void`
  `write(byte[] data, OutputStream output)`
  Writes bytes from a `byte[]` to an `OutputStream`.
  `static void`
  `write(byte[] data, Writer writer)`
  Deprecated.
  2.5 use `write(byte[], Writer, Charset)` instead
  `static void`
  `write(byte[] data, Writer writer, String charsetName)`
  Writes bytes from a `byte[]` to chars on a `Writer` using the specified character encoding.
  `static void`
  `write(byte[] data, Writer writer, Charset charset)`
  Writes bytes from a `byte[]` to chars on a `Writer` using the specified character encoding.
  `static void`
  `write(char[] data, OutputStream output)`
  Deprecated.
  2.5 use `write(char[], OutputStream, Charset)` instead
  `static void`
  `write(char[] data, OutputStream output, String charsetName)`
  Writes chars from a `char[]` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(char[] data, OutputStream output, Charset charset)`
  Writes chars from a `char[]` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(char[] data, Writer writer)`
  Writes chars from a `char[]` to a `Writer`
  `static void`
  `write(CharSequence data, OutputStream output)`
  Deprecated.
  2.5 use `write(CharSequence, OutputStream, Charset)` instead
  `static void`
  `write(CharSequence data, OutputStream output, String charsetName)`
  Writes chars from a `CharSequence` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(CharSequence data, OutputStream output, Charset charset)`
  Writes chars from a `CharSequence` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(CharSequence data, Writer writer)`
  Writes chars from a `CharSequence` to a `Writer`.
  `static void`
  `write(StringBuffer data, OutputStream output)`
  Deprecated.
  Use `write(CharSequence, OutputStream)`
  `static void`
  `write(StringBuffer data, OutputStream output, String charsetName)`
  Deprecated.
  Use `write(CharSequence, OutputStream, String)`.
  `static void`
  `write(StringBuffer data, Writer writer)`
  Deprecated.
  Use `write(CharSequence, Writer)`
  `static void`
  `write(String data, OutputStream output)`
  Deprecated.
  2.5 use `write(String, OutputStream, Charset)` instead
  `static void`
  `write(String data, OutputStream output, String charsetName)`
  Writes chars from a `String` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(String data, OutputStream output, Charset charset)`
  Writes chars from a `String` to bytes on an `OutputStream` using the specified character encoding.
  `static void`
  `write(String data, Writer writer)`
  Writes chars from a `String` to a `Writer`.
  `static void`
  `writeChunked(byte[] data, OutputStream output)`
  Writes bytes from a `byte[]` to an `OutputStream` using chunked writes.
  `static void`
  `writeChunked(char[] data, Writer writer)`
  Writes chars from a `char[]` to a `Writer` using chunked writes.
  `static void`
  `writeLines(Collection<?> lines, String lineEnding, OutputStream output)`
  Deprecated.
  2.5 use `writeLines(Collection, String, OutputStream, Charset)` instead
  `static void`
  `writeLines(Collection<?> lines, String lineEnding, OutputStream output, String charsetName)`
  Writes the `Object.toString()` value of each item in a collection to an `OutputStream` line by line, using the specified character encoding and the specified line ending.
  `static void`
  `writeLines(Collection<?> lines, String lineEnding, OutputStream output, Charset charset)`
  Writes the `Object.toString()` value of each item in a collection to an `OutputStream` line by line, using the specified character encoding and the specified line ending.
  `static void`
  `writeLines(Collection<?> lines, String lineEnding, Writer writer)`
  Writes the `Object.toString()` value of each item in a collection to a `Writer` line by line, using the specified line ending.
  `static Writer`
  `writer(Appendable appendable)`
  Returns the given Appendable if it is already a `Writer`, otherwise creates a Writer wrapper around the given Appendable.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### CR

    public static final int CR
    CR char.
    Since:
      2.9.0
    See Also:
      - Constant Field Values

  - ### DEFAULT_BUFFER_SIZE

    public static final int DEFAULT_BUFFER_SIZE
    The default buffer size (8192) to use in copy methods.
    See Also:
      - Constant Field Values

  - ### DIR_SEPARATOR

    public static final char DIR_SEPARATOR
    The system directory separator character.

  - ### DIR_SEPARATOR_UNIX

    public static final char DIR_SEPARATOR_UNIX
    The Unix directory separator character.
    See Also:
      - Constant Field Values

  - ### DIR_SEPARATOR_WINDOWS

    public static final char DIR_SEPARATOR_WINDOWS
    The Windows directory separator character.
    See Also:
      - Constant Field Values

  - ### EMPTY_BYTE_ARRAY

    public static final byte[] EMPTY_BYTE_ARRAY
    A singleton empty byte array.
    Since:
      2.9.0

  - ### EOF

    public static final int EOF
    Represents the end-of-file (or stream).
    Since:
      2.5 (made public)
    See Also:
      - Constant Field Values

  - ### LF

    public static final int LF
    LF char.
    Since:
      2.9.0
    See Also:
      - Constant Field Values

  - ### LINE_SEPARATOR

    @Deprecated public static final String LINE_SEPARATOR
    Deprecated.
    Use `System.lineSeparator()`.
    The system line separator string.

  - ### LINE_SEPARATOR_UNIX

    public static final String LINE_SEPARATOR_UNIX
    The Unix line separator string.
    See Also:
      - `StandardLineSeparator.LF`

  - ### LINE_SEPARATOR_WINDOWS

    public static final String LINE_SEPARATOR_WINDOWS
    The Windows line separator string.
    See Also:
      - `StandardLineSeparator.CRLF`

- ## Constructor Details

  - ### IOUtils

    @Deprecated public IOUtils()
    Deprecated.
    Will be private in 3.0.
    Instances should NOT be constructed in standard programming.

- ## Method Details

  - ### buffer

    public static BufferedInputStream buffer(InputStream inputStream)
    Returns the given InputStream if it is already a `BufferedInputStream`, otherwise creates a BufferedInputStream from the given InputStream.
    Parameters:
      `inputStream` - the InputStream to wrap or return (not null)
    Returns:
      the given InputStream or a new `BufferedInputStream` for the given InputStream
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedInputStream buffer(InputStream inputStream, int size)
    Returns the given InputStream if it is already a `BufferedInputStream`, otherwise creates a BufferedInputStream from the given InputStream.
    Parameters:
      `inputStream` - the InputStream to wrap or return (not null)
      `size` - the buffer size, if a new BufferedInputStream is created.
    Returns:
      the given InputStream or a new `BufferedInputStream` for the given InputStream
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedOutputStream buffer(OutputStream outputStream)
    Returns the given OutputStream if it is already a `BufferedOutputStream`, otherwise creates a BufferedOutputStream from the given OutputStream.
    Parameters:
      `outputStream` - the OutputStream to wrap or return (not null)
    Returns:
      the given OutputStream or a new `BufferedOutputStream` for the given OutputStream
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedOutputStream buffer(OutputStream outputStream, int size)
    Returns the given OutputStream if it is already a `BufferedOutputStream`, otherwise creates a BufferedOutputStream from the given OutputStream.
    Parameters:
      `outputStream` - the OutputStream to wrap or return (not null)
      `size` - the buffer size, if a new BufferedOutputStream is created.
    Returns:
      the given OutputStream or a new `BufferedOutputStream` for the given OutputStream
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedReader buffer(Reader reader)
    Returns the given reader if it is already a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
    Parameters:
      `reader` - the reader to wrap or return (not null)
    Returns:
      the given reader or a new `BufferedReader` for the given reader
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedReader buffer(Reader reader, int size)
    Returns the given reader if it is already a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
    Parameters:
      `reader` - the reader to wrap or return (not null)
      `size` - the buffer size, if a new BufferedReader is created.
    Returns:
      the given reader or a new `BufferedReader` for the given reader
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedWriter buffer(Writer writer)
    Returns the given Writer if it is already a `BufferedWriter`, otherwise creates a BufferedWriter from the given Writer.
    Parameters:
      `writer` - the Writer to wrap or return (not null)
    Returns:
      the given Writer or a new `BufferedWriter` for the given Writer
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### buffer

    public static BufferedWriter buffer(Writer writer, int size)
    Returns the given Writer if it is already a `BufferedWriter`, otherwise creates a BufferedWriter from the given Writer.
    Parameters:
      `writer` - the Writer to wrap or return (not null)
      `size` - the buffer size, if a new BufferedWriter is created.
    Returns:
      the given Writer or a new `BufferedWriter` for the given Writer
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5

  - ### byteArray

    public static byte[] byteArray()
    Returns a new byte array of size `DEFAULT_BUFFER_SIZE`.
    Returns:
      a new byte array of size `DEFAULT_BUFFER_SIZE`.
    Since:
      2.9.0

  - ### byteArray

    public static byte[] byteArray(int size)
    Returns a new byte array of the given size. TODO Consider guarding or warning against large allocations...
    Parameters:
      `size` - array size.
    Returns:
      a new byte array of the given size.
    Throws:
      `NegativeArraySizeException` - if the size is negative.
    Since:
      2.9.0

  - ### close

    public static void close(Closeable closeable) throws IOException
    Closes the given `Closeable` as a null-safe operation.
    Parameters:
      `closeable` - The resource to close, may be null.
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      2.7

  - ### close

    public static void close(Closeable... closeables) throws IOExceptionList
    Closes the given `Closeable`s as null-safe operations.
    Parameters:
      `closeables` - The resource(s) to close, may be null.
    Throws:
      `IOExceptionList` - if an I/O error occurs.
    Since:
      2.8.0

  - ### close

    public static void close(Closeable closeable, IOConsumer<IOException> consumer) throws IOException
    Closes the given `Closeable` as a null-safe operation.
    Parameters:
      `closeable` - The resource to close, may be null.
      `consumer` - Consume the IOException thrown by `Closeable.close()`.
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      2.7

  - ### close

    public static void close(URLConnection conn)
    Closes a URLConnection.
    Parameters:
      `conn` - the connection to close.
    Since:
      2.4

  - ### closeQuietly

    public static void closeQuietly(Closeable closeable)
    Closes a `Closeable` unconditionally.

    Equivalent to `Closeable.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

         Closeable closeable = null;
         try {
             closeable = new FileReader("foo.txt");
             // process closeable
             closeable.close();
         } catch (Exception e) {
             // error handling
         } finally {
             IOUtils.closeQuietly(closeable);
         }

    Closing all streams:

         try {
             return IOUtils.copy(inputStream, outputStream);
         } finally {
             IOUtils.closeQuietly(inputStream);
             IOUtils.closeQuietly(outputStream);
         }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `closeable` - the objects to close, may be null or already closed
    Since:
      2.0
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Closeable... closeables)
    Closes a `Closeable` unconditionally.

    Equivalent to `Closeable.close()`, except any exceptions will be ignored.

    This is typically used in finally blocks to ensure that the closeable is closed even if an Exception was thrown before the normal close statement was reached.
    It should not be used to replace the close statement(s) which should be present for the non-exceptional case.
    It is only intended to simplify tidying up where normal processing has already failed and reporting close failure as well is not necessary or useful.

    Example code:

         Closeable closeable = null;
         try {
             closeable = new FileReader("foo.txt");
             // processing using the closeable; may throw an Exception
             closeable.close(); // Normal close - exceptions not ignored
         } catch (Exception e) {
             // error handling
         } finally {
             IOUtils.closeQuietly(closeable); // In case normal close was skipped due to Exception
         }

    Closing all streams:

         try {
             return IOUtils.copy(inputStream, outputStream);
         } finally {
             IOUtils.closeQuietly(inputStream, outputStream);
         }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `closeables` - the objects to close, may be null or already closed
    Since:
      2.5
    See Also:
      - `closeQuietly(Closeable)`
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Closeable closeable, Consumer<IOException> consumer)
    Closes the given `Closeable` as a null-safe operation while consuming IOException by the given `consumer`.
    Parameters:
      `closeable` - The resource to close, may be null.
      `consumer` - Consumes the IOException thrown by `Closeable.close()`.
    Since:
      2.7

  - ### closeQuietly

    public static void closeQuietly(InputStream input)
    Closes an `InputStream` unconditionally.

    Equivalent to `InputStream.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           byte[] data = new byte[1024];
           InputStream in = null;
           try {
               in = new FileInputStream("foo.txt");
               in.read(data);
               in.close(); //close errors are handled
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(in);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `input` - the InputStream to close, may be null or already closed
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Iterable<Closeable> closeables)
    Closes an iterable of `Closeable` unconditionally.

    Equivalent calling `Closeable.close()` on each element, except any exceptions will be ignored.

    Parameters:
      `closeables` - the objects to close, may be null or already closed
    Since:
      2.12.0
    See Also:
      - `closeQuietly(Closeable)`

  - ### closeQuietly

    public static void closeQuietly(OutputStream output)
    Closes an `OutputStream` unconditionally.

    Equivalent to `OutputStream.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

         byte[] data = "Hello, World".getBytes();

         OutputStream out = null;
         try {
             out = new FileOutputStream("foo.txt");
             out.write(data);
             out.close(); //close errors are handled
         } catch (IOException e) {
             // error handling
         } finally {
             IOUtils.closeQuietly(out);
         }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `output` - the OutputStream to close, may be null or already closed
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Reader reader)
    Closes an `Reader` unconditionally.

    Equivalent to `Reader.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           char[] data = new char[1024];
           Reader in = null;
           try {
               in = new FileReader("foo.txt");
               in.read(data);
               in.close(); //close errors are handled
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(in);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `reader` - the Reader to close, may be null or already closed
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Selector selector)
    Closes a `Selector` unconditionally.

    Equivalent to `Selector.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           Selector selector = null;
           try {
               selector = Selector.open();
               // process socket

           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(selector);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `selector` - the Selector to close, may be null or already closed
    Since:
      2.2
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(ServerSocket serverSocket)
    Closes a `ServerSocket` unconditionally.

    Equivalent to `ServerSocket.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           ServerSocket socket = null;
           try {
               socket = new ServerSocket();
               // process socket
               socket.close();
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(socket);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `serverSocket` - the ServerSocket to close, may be null or already closed
    Since:
      2.2
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Socket socket)
    Closes a `Socket` unconditionally.

    Equivalent to `Socket.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           Socket socket = null;
           try {
               socket = new Socket("http://www.foo.com/", 80);
               // process socket
               socket.close();
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(socket);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `socket` - the Socket to close, may be null or already closed
    Since:
      2.0
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### closeQuietly

    public static void closeQuietly(Stream<Closeable> closeables)
    Closes a stream of `Closeable` unconditionally.

    Equivalent calling `Closeable.close()` on each element, except any exceptions will be ignored.

    Parameters:
      `closeables` - the objects to close, may be null or already closed
    Since:
      2.12.0
    See Also:
      - `closeQuietly(Closeable)`

  - ### closeQuietly

    public static void closeQuietly(Writer writer)
    Closes an `Writer` unconditionally.

    Equivalent to `Writer.close()`, except any exceptions will be ignored. This is typically used in finally blocks.

    Example code:

           Writer out = null;
           try {
               out = new StringWriter();
               out.write("Hello World");
               out.close(); //close errors are handled
           } catch (Exception e) {
               // error handling
           } finally {
               IOUtils.closeQuietly(out);
           }

    Also consider using a try-with-resources statement where appropriate.

    Parameters:
      `writer` - the Writer to close, may be null or already closed
    See Also:
      - `Throwable.addSuppressed(Throwable)`

  - ### consume

    public static long consume(InputStream input) throws IOException
    Consumes bytes from a `InputStream` and ignores them.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `input` - the `InputStream` to read.
    Returns:
      the number of bytes copied. or `0` if `input is null`.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.8.0

  - ### consume

    public static long consume(Reader input) throws IOException
    Consumes characters from a `Reader` and ignores them.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `input` - the `Reader` to read.
    Returns:
      the number of bytes copied. or `0` if `input is null`.
    Throws:
      `NullPointerException` - if the Reader is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.12.0

  - ### contentEquals

    public static boolean contentEquals(InputStream input1, InputStream input2) throws IOException
    Compares the contents of two Streams to determine if they are equal or not.

    This method buffers the input internally using `BufferedInputStream` if they are not already buffered.

    Parameters:
      `input1` - the first stream
      `input2` - the second stream
    Returns:
      true if the content of the streams are equal or they both don't exist, false otherwise
    Throws:
      `IOException` - if an I/O error occurs

  - ### contentEquals

    public static boolean contentEquals(Reader input1, Reader input2) throws IOException
    Compares the contents of two Readers to determine if they are equal or not.

    This method buffers the input internally using `BufferedReader` if they are not already buffered.

    Parameters:
      `input1` - the first reader
      `input2` - the second reader
    Returns:
      true if the content of the readers are equal or they both don't exist, false otherwise
    Throws:
      `NullPointerException` - if either input is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### contentEqualsIgnoreEOL

    public static boolean contentEqualsIgnoreEOL(Reader reader1, Reader reader2) throws UncheckedIOException
    Compares the contents of two Readers to determine if they are equal or not, ignoring EOL characters.

    This method buffers the input internally using `BufferedReader` if they are not already buffered.

    Parameters:
      `reader1` - the first reader
      `reader2` - the second reader
    Returns:
      true if the content of the readers are equal (ignoring EOL differences), false otherwise
    Throws:
      `NullPointerException` - if either input is null
      `UncheckedIOException` - if an I/O error occurs
    Since:
      2.2

  - ### copy

    public static int copy(InputStream inputStream, OutputStream outputStream) throws IOException
    Copies bytes from an `InputStream` to an `OutputStream`.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Large streams (over 2GB) will return a bytes copied value of `-1` after the copy has completed since the correct number of bytes cannot be returned as an int. For large streams use the `copyLarge(InputStream, OutputStream)` method.

    Parameters:
      `inputStream` - the `InputStream` to read.
      `outputStream` - the `OutputStream` to write.
    Returns:
      the number of bytes copied, or -1 if greater than `Integer.MAX_VALUE`.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      1.1

  - ### copy

    public static long copy(InputStream inputStream, OutputStream outputStream, int bufferSize) throws IOException
    Copies bytes from an `InputStream` to an `OutputStream` using an internal buffer of the given size.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read.
      `outputStream` - the `OutputStream` to write to
      `bufferSize` - the bufferSize used to copy from the input to the output
    Returns:
      the number of bytes copied.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.5

  - ### copy

    @Deprecated public static void copy(InputStream input, Writer writer) throws IOException
    Deprecated.
    2.5 use `copy(InputStream, Writer, Charset)` instead
    Copies bytes from an `InputStream` to chars on a `Writer` using the default character encoding of the platform.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    This method uses `InputStreamReader`.

    Parameters:
      `input` - the `InputStream` to read
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### copy

    public static void copy(InputStream input, Writer writer, Charset inputCharset) throws IOException
    Copies bytes from an `InputStream` to chars on a `Writer` using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    This method uses `InputStreamReader`.

    Parameters:
      `input` - the `InputStream` to read
      `writer` - the `Writer` to write to
      `inputCharset` - the charset to use for the input stream, null means platform default
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### copy

    public static void copy(InputStream input, Writer writer, String inputCharsetName) throws IOException
    Copies bytes from an `InputStream` to chars on a `Writer` using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Character encoding names can be found at IANA.

    This method uses `InputStreamReader`.

    Parameters:
      `input` - the `InputStream` to read
      `writer` - the `Writer` to write to
      `inputCharsetName` - the name of the requested charset for the InputStream, null means platform default
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### copy

    public static QueueInputStream copy(ByteArrayOutputStream outputStream) throws IOException
    Copies bytes from a `ByteArrayOutputStream` to a `QueueInputStream`.

    Unlike using JDK `PipedInputStream` and `PipedOutputStream` for this, this solution works safely in a single thread environment.

    Example usage:

         ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
         outputStream.writeBytes("hello world".getBytes(StandardCharsets.UTF_8));

         InputStream inputStream = IOUtils.copy(outputStream);

    Parameters:
      `outputStream` - the `ByteArrayOutputStream` to read.
    Returns:
      the `QueueInputStream` filled with the content of the outputStream.
    Throws:
      `NullPointerException` - if the `ByteArrayOutputStream` is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.12

  - ### copy

    public static long copy(Reader reader, Appendable output) throws IOException
    Copies chars from a `Reader` to a `Appendable`.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Large streams (over 2GB) will return a chars copied value of `-1` after the copy has completed since the correct number of chars cannot be returned as an int. For large streams use the `copyLarge(Reader, Writer)` method.

    Parameters:
      `reader` - the `Reader` to read
      `output` - the `Appendable` to write to
    Returns:
      the number of characters copied, or -1 if > Integer.MAX_VALUE
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.7

  - ### copy

    public static long copy(Reader reader, Appendable output, CharBuffer buffer) throws IOException
    Copies chars from a `Reader` to an `Appendable`.

    This method uses the provided buffer, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
      `output` - the `Appendable` to write to
      `buffer` - the buffer to be used for the copy
    Returns:
      the number of characters copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.7

  - ### copy

    @Deprecated public static void copy(Reader reader, OutputStream output) throws IOException
    Deprecated.
    2.5 use `copy(Reader, OutputStream, Charset)` instead
    Copies chars from a `Reader` to bytes on an `OutputStream` using the default character encoding of the platform, and calling flush.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Due to the implementation of OutputStreamWriter, this method performs a flush.

    This method uses `OutputStreamWriter`.

    Parameters:
      `reader` - the `Reader` to read
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### copy

    public static void copy(Reader reader, OutputStream output, Charset outputCharset) throws IOException
    Copies chars from a `Reader` to bytes on an `OutputStream` using the specified character encoding, and calling flush.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Due to the implementation of OutputStreamWriter, this method performs a flush.

    This method uses `OutputStreamWriter`.

    Parameters:
      `reader` - the `Reader` to read
      `output` - the `OutputStream` to write to
      `outputCharset` - the charset to use for the OutputStream, null means platform default
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### copy

    public static void copy(Reader reader, OutputStream output, String outputCharsetName) throws IOException
    Copies chars from a `Reader` to bytes on an `OutputStream` using the specified character encoding, and calling flush.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Character encoding names can be found at IANA.

    Due to the implementation of OutputStreamWriter, this method performs a flush.

    This method uses `OutputStreamWriter`.

    Parameters:
      `reader` - the `Reader` to read
      `output` - the `OutputStream` to write to
      `outputCharsetName` - the name of the requested charset for the OutputStream, null means platform default
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### copy

    public static int copy(Reader reader, Writer writer) throws IOException
    Copies chars from a `Reader` to a `Writer`.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Large streams (over 2GB) will return a chars copied value of `-1` after the copy has completed since the correct number of chars cannot be returned as an int. For large streams use the `copyLarge(Reader, Writer)` method.

    Parameters:
      `reader` - the `Reader` to read.
      `writer` - the `Writer` to write.
    Returns:
      the number of characters copied, or -1 if > Integer.MAX_VALUE
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### copy

    public static long copy(URL url, File file) throws IOException
    Copies bytes from a `URL` to an `OutputStream`.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `url` - the `URL` to read.
      `file` - the `OutputStream` to write.
    Returns:
      the number of bytes copied.
    Throws:
      `NullPointerException` - if the URL is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.9.0

  - ### copy

    public static long copy(URL url, OutputStream outputStream) throws IOException
    Copies bytes from a `URL` to an `OutputStream`.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `url` - the `URL` to read.
      `outputStream` - the `OutputStream` to write.
    Returns:
      the number of bytes copied.
    Throws:
      `NullPointerException` - if the URL is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.9.0

  - ### copyLarge

    public static long copyLarge(InputStream inputStream, OutputStream outputStream) throws IOException
    Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `inputStream` - the `InputStream` to read.
      `outputStream` - the `OutputStream` to write.
    Returns:
      the number of bytes copied.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      1.3

  - ### copyLarge

    public static long copyLarge(InputStream inputStream, OutputStream outputStream, byte[] buffer) throws IOException
    Copies bytes from a large (over 2GB) `InputStream` to an `OutputStream`.

    This method uses the provided buffer, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read.
      `outputStream` - the `OutputStream` to write.
      `buffer` - the buffer to use for the copy
    Returns:
      the number of bytes copied.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `NullPointerException` - if the OutputStream is `null`.
      `IOException` - if an I/O error occurs.
    Since:
      2.2

  - ### copyLarge

    public static long copyLarge(InputStream input, OutputStream output, long inputOffset, long length) throws IOException
    Copies some or all bytes from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input bytes.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Note that the implementation uses `skip(InputStream, long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.
    Parameters:
      `input` - the `InputStream` to read
      `output` - the `OutputStream` to write to
      `inputOffset` - : number of bytes to skip from input before copying -ve values are ignored
      `length` - : number of bytes to copy. -ve means all
    Returns:
      the number of bytes copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.2

  - ### copyLarge

    public static long copyLarge(InputStream input, OutputStream output, long inputOffset, long length, byte[] buffer) throws IOException
    Copies some or all bytes from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input bytes.

    This method uses the provided buffer, so there is no need to use a `BufferedInputStream`.

    Note that the implementation uses `skip(InputStream, long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    Parameters:
      `input` - the `InputStream` to read
      `output` - the `OutputStream` to write to
      `inputOffset` - : number of bytes to skip from input before copying -ve values are ignored
      `length` - : number of bytes to copy. -ve means all
      `buffer` - the buffer to use for the copy
    Returns:
      the number of bytes copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.2

  - ### copyLarge

    public static long copyLarge(Reader reader, Writer writer) throws IOException
    Copies chars from a large (over 2GB) `Reader` to a `Writer`.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `reader` - the `Reader` to source.
      `writer` - the `Writer` to target.
    Returns:
      the number of characters copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      1.3

  - ### copyLarge

    public static long copyLarge(Reader reader, Writer writer, char[] buffer) throws IOException
    Copies chars from a large (over 2GB) `Reader` to a `Writer`.

    This method uses the provided buffer, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to source.
      `writer` - the `Writer` to target.
      `buffer` - the buffer to be used for the copy
    Returns:
      the number of characters copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.2

  - ### copyLarge

    public static long copyLarge(Reader reader, Writer writer, long inputOffset, long length) throws IOException
    Copies some or all chars from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input chars.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    The buffer size is given by `DEFAULT_BUFFER_SIZE`.

    Parameters:
      `reader` - the `Reader` to read
      `writer` - the `Writer` to write to
      `inputOffset` - : number of chars to skip from input before copying -ve values are ignored
      `length` - : number of chars to copy. -ve means all
    Returns:
      the number of chars copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.2

  - ### copyLarge

    public static long copyLarge(Reader reader, Writer writer, long inputOffset, long length, char[] buffer) throws IOException
    Copies some or all chars from a large (over 2GB) `InputStream` to an `OutputStream`, optionally skipping input chars.

    This method uses the provided buffer, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
      `writer` - the `Writer` to write to
      `inputOffset` - : number of chars to skip from input before copying -ve values are ignored
      `length` - : number of chars to copy. -ve means all
      `buffer` - the buffer to be used for the copy
    Returns:
      the number of chars copied
    Throws:
      `NullPointerException` - if the input or output is null
      `IOException` - if an I/O error occurs
    Since:
      2.2

  - ### length

    public static int length(byte[] array)
    Returns the length of the given array in a null-safe manner.
    Parameters:
      `array` - an array or null
    Returns:
      the array length -- or 0 if the given array is null.
    Since:
      2.7

  - ### length

    public static int length(char[] array)
    Returns the length of the given array in a null-safe manner.
    Parameters:
      `array` - an array or null
    Returns:
      the array length -- or 0 if the given array is null.
    Since:
      2.7

  - ### length

    public static int length(CharSequence csq)
    Returns the length of the given CharSequence in a null-safe manner.
    Parameters:
      `csq` - a CharSequence or null
    Returns:
      the CharSequence length -- or 0 if the given CharSequence is null.
    Since:
      2.7

  - ### length

    public static int length(Object[] array)
    Returns the length of the given array in a null-safe manner.
    Parameters:
      `array` - an array or null
    Returns:
      the array length -- or 0 if the given array is null.
    Since:
      2.7

  - ### lineIterator

    public static LineIterator lineIterator(InputStream input, Charset charset)
    Returns an Iterator for the lines in an `InputStream`, using the character encoding specified (or default encoding if null).

    `LineIterator` holds a reference to the open `InputStream` specified here. When you have finished with the iterator you should close the stream to free internal resources. This can be done by using a try-with-resources block, closing the stream directly, or by calling `LineIterator.close()`.

    The recommended usage pattern is:

         try {
           LineIterator it = IOUtils.lineIterator(stream, charset);
           while (it.hasNext()) {
             String line = it.nextLine();
             /// do something with line
           }
         } finally {
           IOUtils.closeQuietly(stream);
         }

    Parameters:
      `input` - the `InputStream` to read, not null
      `charset` - the charset to use, null means platform default
    Returns:
      an Iterator of the lines in the reader, never null
    Throws:
      `IllegalArgumentException` - if the input is null
    Since:
      2.3

  - ### lineIterator

    public static LineIterator lineIterator(InputStream input, String charsetName)
    Returns an Iterator for the lines in an `InputStream`, using the character encoding specified (or default encoding if null).

    `LineIterator` holds a reference to the open `InputStream` specified here. When you have finished with the iterator you should close the stream to free internal resources. This can be done by using a try-with-resources block, closing the stream directly, or by calling `LineIterator.close()`.

    The recommended usage pattern is:

         try {
           LineIterator it = IOUtils.lineIterator(stream, StandardCharsets.UTF_8.name());
           while (it.hasNext()) {
             String line = it.nextLine();
             /// do something with line
           }
         } finally {
           IOUtils.closeQuietly(stream);
         }

    Parameters:
      `input` - the `InputStream` to read, not null
      `charsetName` - the encoding to use, null means platform default
    Returns:
      an Iterator of the lines in the reader, never null
    Throws:
      `IllegalArgumentException` - if the input is null
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.2

  - ### lineIterator

    public static LineIterator lineIterator(Reader reader)
    Returns an Iterator for the lines in a `Reader`.

    `LineIterator` holds a reference to the open `Reader` specified here. When you have finished with the iterator you should close the reader to free internal resources. This can be done by using a try-with-resources block, closing the reader directly, or by calling `LineIterator.close()`.

    The recommended usage pattern is:

         try {
           LineIterator it = IOUtils.lineIterator(reader);
           while (it.hasNext()) {
             String line = it.nextLine();
             /// do something with line
           }
         } finally {
           IOUtils.closeQuietly(reader);
         }

    Parameters:
      `reader` - the `Reader` to read, not null
    Returns:
      an Iterator of the lines in the reader, never null
    Throws:
      `NullPointerException` - if the reader is null
    Since:
      1.2

  - ### read

    public static int read(InputStream input, byte[] buffer) throws IOException
    Reads bytes from an input stream. This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for subclasses of `InputStream`.
    Parameters:
      `input` - where to read input from
      `buffer` - destination
    Returns:
      actual length read; may be less than requested if EOF was reached
    Throws:
      `IOException` - if a read error occurs
    Since:
      2.2

  - ### read

    public static int read(InputStream input, byte[] buffer, int offset, int length) throws IOException
    Reads bytes from an input stream. This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for subclasses of `InputStream`.
    Parameters:
      `input` - where to read input
      `buffer` - destination
      `offset` - initial offset into buffer
      `length` - length to read, must be >= 0
    Returns:
      actual length read; may be less than requested if EOF was reached
    Throws:
      `IllegalArgumentException` - if length is negative
      `IOException` - if a read error occurs
    Since:
      2.2

  - ### read

    public static int read(ReadableByteChannel input, ByteBuffer buffer) throws IOException
    Reads bytes from a ReadableByteChannel.

    This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for subclasses of `ReadableByteChannel`.

    Parameters:
      `input` - the byte channel to read
      `buffer` - byte buffer destination
    Returns:
      the actual length read; may be less than requested if EOF was reached
    Throws:
      `IOException` - if a read error occurs
    Since:
      2.5

  - ### read

    public static int read(Reader reader, char[] buffer) throws IOException
    Reads characters from an input character stream. This implementation guarantees that it will read as many characters as possible before giving up; this may not always be the case for subclasses of `Reader`.
    Parameters:
      `reader` - where to read input from
      `buffer` - destination
    Returns:
      actual length read; may be less than requested if EOF was reached
    Throws:
      `IOException` - if a read error occurs
    Since:
      2.2

  - ### read

    public static int read(Reader reader, char[] buffer, int offset, int length) throws IOException
    Reads characters from an input character stream. This implementation guarantees that it will read as many characters as possible before giving up; this may not always be the case for subclasses of `Reader`.
    Parameters:
      `reader` - where to read input from
      `buffer` - destination
      `offset` - initial offset into buffer
      `length` - length to read, must be >= 0
    Returns:
      actual length read; may be less than requested if EOF was reached
    Throws:
      `IllegalArgumentException` - if length is negative
      `IOException` - if a read error occurs
    Since:
      2.2

  - ### readFully

    public static void readFully(InputStream input, byte[] buffer) throws IOException
    Reads the requested number of bytes or fail if there are not enough left.

    This allows for the possibility that `InputStream.read(byte[], int, int)` may not read as many bytes as requested (most likely because of reaching EOF).

    Parameters:
      `input` - where to read input from
      `buffer` - destination
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if length is negative
      `EOFException` - if the number of bytes read was incorrect
    Since:
      2.2

  - ### readFully

    public static void readFully(InputStream input, byte[] buffer, int offset, int length) throws IOException
    Reads the requested number of bytes or fail if there are not enough left.

    This allows for the possibility that `InputStream.read(byte[], int, int)` may not read as many bytes as requested (most likely because of reaching EOF).

    Parameters:
      `input` - where to read input from
      `buffer` - destination
      `offset` - initial offset into buffer
      `length` - length to read, must be >= 0
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if length is negative
      `EOFException` - if the number of bytes read was incorrect
    Since:
      2.2

  - ### readFully

    public static byte[] readFully(InputStream input, int length) throws IOException
    Reads the requested number of bytes or fail if there are not enough left.

    This allows for the possibility that `InputStream.read(byte[], int, int)` may not read as many bytes as requested (most likely because of reaching EOF).

    Parameters:
      `input` - where to read input from
      `length` - length to read, must be >= 0
    Returns:
      the bytes read from input
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if length is negative
      `EOFException` - if the number of bytes read was incorrect
    Since:
      2.5

  - ### readFully

    public static void readFully(ReadableByteChannel input, ByteBuffer buffer) throws IOException
    Reads the requested number of bytes or fail if there are not enough left.

    This allows for the possibility that `ReadableByteChannel.read(ByteBuffer)` may not read as many bytes as requested (most likely because of reaching EOF).

    Parameters:
      `input` - the byte channel to read
      `buffer` - byte buffer destination
    Throws:
      `IOException` - if there is a problem reading the file
      `EOFException` - if the number of bytes read was incorrect
    Since:
      2.5

  - ### readFully

    public static void readFully(Reader reader, char[] buffer) throws IOException
    Reads the requested number of characters or fail if there are not enough left.

    This allows for the possibility that `Reader.read(char[], int, int)` may not read as many characters as requested (most likely because of reaching EOF).

    Parameters:
      `reader` - where to read input from
      `buffer` - destination
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if length is negative
      `EOFException` - if the number of characters read was incorrect
    Since:
      2.2

  - ### readFully

    public static void readFully(Reader reader, char[] buffer, int offset, int length) throws IOException
    Reads the requested number of characters or fail if there are not enough left.

    This allows for the possibility that `Reader.read(char[], int, int)` may not read as many characters as requested (most likely because of reaching EOF).

    Parameters:
      `reader` - where to read input from
      `buffer` - destination
      `offset` - initial offset into buffer
      `length` - length to read, must be >= 0
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if length is negative
      `EOFException` - if the number of characters read was incorrect
    Since:
      2.2

  - ### readLines

    @Deprecated public static List<String> readLines(InputStream input) throws UncheckedIOException
    Deprecated.
    2.5 use `readLines(InputStream, Charset)` instead
    Gets the contents of an `InputStream` as a list of Strings, one entry per line, using the default character encoding of the platform.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read, not null
    Returns:
      the list of Strings, never null
    Throws:
      `NullPointerException` - if the input is null
      `UncheckedIOException` - if an I/O error occurs
    Since:
      1.1

  - ### readLines

    public static List<String> readLines(InputStream input, Charset charset) throws UncheckedIOException
    Gets the contents of an `InputStream` as a list of Strings, one entry per line, using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read, not null
      `charset` - the charset to use, null means platform default
    Returns:
      the list of Strings, never null
    Throws:
      `NullPointerException` - if the input is null
      `UncheckedIOException` - if an I/O error occurs
    Since:
      2.3

  - ### readLines

    public static List<String> readLines(InputStream input, String charsetName) throws UncheckedIOException
    Gets the contents of an `InputStream` as a list of Strings, one entry per line, using the specified character encoding.

    Character encoding names can be found at IANA.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read, not null
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      the list of Strings, never null
    Throws:
      `NullPointerException` - if the input is null
      `UncheckedIOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### readLines

    public static List<String> readLines(Reader reader) throws UncheckedIOException
    Gets the contents of a `Reader` as a list of Strings, one entry per line.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read, not null
    Returns:
      the list of Strings, never null
    Throws:
      `NullPointerException` - if the input is null
      `UncheckedIOException` - if an I/O error occurs
    Since:
      1.1

  - ### resourceToByteArray

    public static byte[] resourceToByteArray(String name) throws IOException
    Gets the contents of a resource as a byte array.

    Delegates to `resourceToByteArray(String, null)`.

    Parameters:
      `name` - The resource name.
    Returns:
      the requested byte array
    Throws:
      `IOException` - if an I/O error occurs or the resource is not found.
    Since:
      2.6
    See Also:
      - `resourceToByteArray(String, ClassLoader)`

  - ### resourceToByteArray

    public static byte[] resourceToByteArray(String name, ClassLoader classLoader) throws IOException
    Gets the contents of a resource as a byte array.

    Delegates to `resourceToURL(String, ClassLoader)`.

    Parameters:
      `name` - The resource name.
      `classLoader` - the class loader that the resolution of the resource is delegated to
    Returns:
      the requested byte array
    Throws:
      `IOException` - if an I/O error occurs or the resource is not found.
    Since:
      2.6
    See Also:
      - `resourceToURL(String, ClassLoader)`

  - ### resourceToString

    public static String resourceToString(String name, Charset charset) throws IOException
    Gets the contents of a resource as a String using the specified character encoding.

    Delegates to `resourceToString(String, Charset, null)`.

    Parameters:
      `name` - The resource name.
      `charset` - the charset to use, null means platform default
    Returns:
      the requested String
    Throws:
      `IOException` - if an I/O error occurs or the resource is not found.
    Since:
      2.6
    See Also:
      - `resourceToString(String, Charset, ClassLoader)`

  - ### resourceToString

    public static String resourceToString(String name, Charset charset, ClassLoader classLoader) throws IOException
    Gets the contents of a resource as a String using the specified character encoding.

    Delegates to `resourceToURL(String, ClassLoader)`.

    Parameters:
      `name` - The resource name.
      `charset` - the Charset to use, null means platform default
      `classLoader` - the class loader that the resolution of the resource is delegated to
    Returns:
      the requested String
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      2.6
    See Also:
      - `resourceToURL(String, ClassLoader)`

  - ### resourceToURL

    public static URL resourceToURL(String name) throws IOException
    Gets a URL pointing to the given resource.

    Delegates to `resourceToURL(String, null)`.

    Parameters:
      `name` - The resource name.
    Returns:
      A URL object for reading the resource.
    Throws:
      `IOException` - if the resource is not found.
    Since:
      2.6

  - ### resourceToURL

    public static URL resourceToURL(String name, ClassLoader classLoader) throws IOException
    Gets a URL pointing to the given resource.

    If the `classLoader` is not null, call `ClassLoader.getResource(String)`, otherwise call `IOUtils.class.getResource(name)`.

    Parameters:
      `name` - The resource name.
      `classLoader` - Delegate to this class loader if not null
    Returns:
      A URL object for reading the resource.
    Throws:
      `IOException` - if the resource is not found.
    Since:
      2.6

  - ### skip

    public static long skip(InputStream input, long toSkip) throws IOException
    Skips bytes from an input byte stream. This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for skip() implementations in subclasses of `InputStream`.

    Note that the implementation uses `InputStream.read(byte[], int, int)` rather than delegating to `InputStream.skip(long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of bytes are skipped.

    Parameters:
      `input` - byte stream to skip
      `toSkip` - number of bytes to skip.
    Returns:
      number of bytes actually skipped.
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
    Since:
      2.0
    See Also:
      - `InputStream.skip(long)`
      - IO-203 - Add skipFully() method for InputStreams

  - ### skip

    public static long skip(InputStream input, long toSkip, Supplier<byte[]> skipBufferSupplier) throws IOException
    Skips bytes from an input byte stream.

    Intended for special cases when customization of the temporary buffer is needed because, for example, a nested input stream has requirements for the bytes read. For example, when using `InflaterInputStream`s from multiple threads.

    This implementation guarantees that it will read as many bytes as possible before giving up; this may not always be the case for skip() implementations in subclasses of `InputStream`.

    Note that the implementation uses `InputStream.read(byte[], int, int)` rather than delegating to `InputStream.skip(long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of bytes are skipped.

    Parameters:
      `input` - byte stream to skip
      `toSkip` - number of bytes to skip.
      `skipBufferSupplier` - Supplies the buffer to use for reading.
    Returns:
      number of bytes actually skipped.
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
    Since:
      2.14.0
    See Also:
      - `InputStream.skip(long)`
      - IO-203 - Add skipFully() method for InputStreams

  - ### skip

    public static long skip(ReadableByteChannel input, long toSkip) throws IOException
    Skips bytes from a ReadableByteChannel. This implementation guarantees that it will read as many bytes as possible before giving up.
    Parameters:
      `input` - ReadableByteChannel to skip
      `toSkip` - number of bytes to skip.
    Returns:
      number of bytes actually skipped.
    Throws:
      `IOException` - if there is a problem reading the ReadableByteChannel
      `IllegalArgumentException` - if toSkip is negative
    Since:
      2.5

  - ### skip

    public static long skip(Reader reader, long toSkip) throws IOException
    Skips characters from an input character stream. This implementation guarantees that it will read as many characters as possible before giving up; this may not always be the case for skip() implementations in subclasses of `Reader`.

    Note that the implementation uses `Reader.read(char[], int, int)` rather than delegating to `Reader.skip(long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    Parameters:
      `reader` - character stream to skip
      `toSkip` - number of characters to skip.
    Returns:
      number of characters actually skipped.
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
    Since:
      2.0
    See Also:
      - `Reader.skip(long)`
      - IO-203 - Add skipFully() method for InputStreams

  - ### skipFully

    public static void skipFully(InputStream input, long toSkip) throws IOException
    Skips the requested number of bytes or fail if there are not enough left.

    This allows for the possibility that `InputStream.skip(long)` may not skip as many bytes as requested (most likely because of reaching EOF).

    Note that the implementation uses `skip(InputStream, long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    Parameters:
      `input` - stream to skip
      `toSkip` - the number of bytes to skip
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
      `EOFException` - if the number of bytes skipped was incorrect
    Since:
      2.0
    See Also:
      - `InputStream.skip(long)`

  - ### skipFully

    public static void skipFully(InputStream input, long toSkip, Supplier<byte[]> skipBufferSupplier) throws IOException
    Skips the requested number of bytes or fail if there are not enough left.

    Intended for special cases when customization of the temporary buffer is needed because, for example, a nested input stream has requirements for the bytes read. For example, when using `InflaterInputStream`s from multiple threads.

    This allows for the possibility that `InputStream.skip(long)` may not skip as many bytes as requested (most likely because of reaching EOF).

    Note that the implementation uses `skip(InputStream, long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    Parameters:
      `input` - stream to skip
      `toSkip` - the number of bytes to skip
      `skipBufferSupplier` - Supplies the buffer to use for reading.
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
      `EOFException` - if the number of bytes skipped was incorrect
    Since:
      2.14.0
    See Also:
      - `InputStream.skip(long)`

  - ### skipFully

    public static void skipFully(ReadableByteChannel input, long toSkip) throws IOException
    Skips the requested number of bytes or fail if there are not enough left.
    Parameters:
      `input` - ReadableByteChannel to skip
      `toSkip` - the number of bytes to skip
    Throws:
      `IOException` - if there is a problem reading the ReadableByteChannel
      `IllegalArgumentException` - if toSkip is negative
      `EOFException` - if the number of bytes skipped was incorrect
    Since:
      2.5

  - ### skipFully

    public static void skipFully(Reader reader, long toSkip) throws IOException
    Skips the requested number of characters or fail if there are not enough left.

    This allows for the possibility that `Reader.skip(long)` may not skip as many characters as requested (most likely because of reaching EOF).

    Note that the implementation uses `skip(Reader, long)`. This means that the method may be considerably less efficient than using the actual skip implementation, this is done to guarantee that the correct number of characters are skipped.

    Parameters:
      `reader` - stream to skip
      `toSkip` - the number of characters to skip
    Throws:
      `IOException` - if there is a problem reading the file
      `IllegalArgumentException` - if toSkip is negative
      `EOFException` - if the number of characters skipped was incorrect
    Since:
      2.0
    See Also:
      - `Reader.skip(long)`

  - ### toBufferedInputStream

    public static InputStream toBufferedInputStream(InputStream input) throws IOException
    Fetches entire contents of an `InputStream` and represent same data as result InputStream.

    This method is useful where,

    - Source InputStream is slow.
    - It has network resources associated, so we cannot keep it open for long time.
    - It has network timeout associated.

    It can be used in favor of `toByteArray(InputStream)`, since it avoids unnecessary allocation and copy of byte[].
    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - Stream to be fully buffered.
    Returns:
      A fully buffered stream.
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      2.0

  - ### toBufferedInputStream

    public static InputStream toBufferedInputStream(InputStream input, int size) throws IOException
    Fetches entire contents of an `InputStream` and represent same data as result InputStream.

    This method is useful where,

    - Source InputStream is slow.
    - It has network resources associated, so we cannot keep it open for long time.
    - It has network timeout associated.

    It can be used in favor of `toByteArray(InputStream)`, since it avoids unnecessary allocation and copy of byte[].
    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - Stream to be fully buffered.
      `size` - the initial buffer size
    Returns:
      A fully buffered stream.
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      2.5

  - ### toBufferedReader

    public static BufferedReader toBufferedReader(Reader reader)
    Returns the given reader if it is a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
    Parameters:
      `reader` - the reader to wrap or return (not null)
    Returns:
      the given reader or a new `BufferedReader` for the given reader
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.2
    See Also:
      - `buffer(Reader)`

  - ### toBufferedReader

    public static BufferedReader toBufferedReader(Reader reader, int size)
    Returns the given reader if it is a `BufferedReader`, otherwise creates a BufferedReader from the given reader.
    Parameters:
      `reader` - the reader to wrap or return (not null)
      `size` - the buffer size, if a new BufferedReader is created.
    Returns:
      the given reader or a new `BufferedReader` for the given reader
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.5
    See Also:
      - `buffer(Reader)`

  - ### toByteArray

    public static byte[] toByteArray(InputStream inputStream) throws IOException
    Gets the contents of an `InputStream` as a `byte[]`.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read.
    Returns:
      the requested byte array.
    Throws:
      `NullPointerException` - if the InputStream is `null`.
      `IOException` - if an I/O error occurs or reading more than `Integer.MAX_VALUE` occurs.

  - ### toByteArray

    public static byte[] toByteArray(InputStream input, int size) throws IOException
    Gets the contents of an `InputStream` as a `byte[]`. Use this method instead of `toByteArray(InputStream)` when `InputStream` size is known.
    Parameters:
      `input` - the `InputStream` to read.
      `size` - the size of `InputStream` to read, where 0 < `size` <= length of input stream.
    Returns:
      byte [] of length `size`.
    Throws:
      `IOException` - if an I/O error occurs or `InputStream` length is smaller than parameter `size`.
      `IllegalArgumentException` - if `size` is less than zero.
    Since:
      2.1

  - ### toByteArray

    public static byte[] toByteArray(InputStream input, long size) throws IOException
    Gets contents of an `InputStream` as a `byte[]`. Use this method instead of `toByteArray(InputStream)` when `InputStream` size is known. NOTE: the method checks that the length can safely be cast to an int without truncation before using `toByteArray(InputStream, int)` to read into the byte array. (Arrays can have no more than Integer.MAX_VALUE entries anyway)
    Parameters:
      `input` - the `InputStream` to read
      `size` - the size of `InputStream` to read, where 0 < `size` <= min(Integer.MAX_VALUE, length of input stream).
    Returns:
      byte [] the requested byte array, of length `size`
    Throws:
      `IOException` - if an I/O error occurs or `InputStream` length is less than `size`
      `IllegalArgumentException` - if size is less than zero or size is greater than Integer.MAX_VALUE
    Since:
      2.1
    See Also:
      - `toByteArray(InputStream, int)`

  - ### toByteArray

    @Deprecated public static byte[] toByteArray(Reader reader) throws IOException
    Deprecated.
    2.5 use `toByteArray(Reader, Charset)` instead
    Gets the contents of a `Reader` as a `byte[]` using the default character encoding of the platform.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs

  - ### toByteArray

    public static byte[] toByteArray(Reader reader, Charset charset) throws IOException
    Gets the contents of a `Reader` as a `byte[]` using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
      `charset` - the charset to use, null means platform default
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### toByteArray

    public static byte[] toByteArray(Reader reader, String charsetName) throws IOException
    Gets the contents of a `Reader` as a `byte[]` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### toByteArray

    @Deprecated public static byte[] toByteArray(String input)
    Deprecated.
    2.5 Use `String.getBytes()` instead
    Gets the contents of a `String` as a `byte[]` using the default character encoding of the platform.

    This is the same as `String.getBytes()`.

    Parameters:
      `input` - the `String` to convert
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the input is null

  - ### toByteArray

    public static byte[] toByteArray(URI uri) throws IOException
    Gets the contents of a `URI` as a `byte[]`.
    Parameters:
      `uri` - the `URI` to read
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the uri is null
      `IOException` - if an I/O exception occurs
    Since:
      2.4

  - ### toByteArray

    public static byte[] toByteArray(URL url) throws IOException
    Gets the contents of a `URL` as a `byte[]`.
    Parameters:
      `url` - the `URL` to read
    Returns:
      the requested byte array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O exception occurs
    Since:
      2.4

  - ### toByteArray

    public static byte[] toByteArray(URLConnection urlConnection) throws IOException
    Gets the contents of a `URLConnection` as a `byte[]`.
    Parameters:
      `urlConnection` - the `URLConnection` to read.
    Returns:
      the requested byte array.
    Throws:
      `NullPointerException` - if the urlConn is null.
      `IOException` - if an I/O exception occurs.
    Since:
      2.4

  - ### toCharArray

    @Deprecated public static char[] toCharArray(InputStream inputStream) throws IOException
    Deprecated.
    2.5 use `toCharArray(InputStream, Charset)` instead
    Gets the contents of an `InputStream` as a character array using the default character encoding of the platform.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read
    Returns:
      the requested character array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### toCharArray

    public static char[] toCharArray(InputStream inputStream, Charset charset) throws IOException
    Gets the contents of an `InputStream` as a character array using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read
      `charset` - the charset to use, null means platform default
    Returns:
      the requested character array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### toCharArray

    public static char[] toCharArray(InputStream inputStream, String charsetName) throws IOException
    Gets the contents of an `InputStream` as a character array using the specified character encoding.

    Character encoding names can be found at IANA.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `inputStream` - the `InputStream` to read
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      the requested character array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### toCharArray

    public static char[] toCharArray(Reader reader) throws IOException
    Gets the contents of a `Reader` as a character array.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
    Returns:
      the requested character array
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### toInputStream

    @Deprecated public static InputStream toInputStream(CharSequence input)
    Deprecated.
    2.5 use `toInputStream(CharSequence, Charset)` instead
    Converts the specified CharSequence to an input stream, encoded as bytes using the default character encoding of the platform.
    Parameters:
      `input` - the CharSequence to convert
    Returns:
      an input stream
    Since:
      2.0

  - ### toInputStream

    public static InputStream toInputStream(CharSequence input, Charset charset)
    Converts the specified CharSequence to an input stream, encoded as bytes using the specified character encoding.
    Parameters:
      `input` - the CharSequence to convert
      `charset` - the charset to use, null means platform default
    Returns:
      an input stream
    Since:
      2.3

  - ### toInputStream

    public static InputStream toInputStream(CharSequence input, String charsetName)
    Converts the specified CharSequence to an input stream, encoded as bytes using the specified character encoding.

    Character encoding names can be found at IANA.

    Parameters:
      `input` - the CharSequence to convert
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      an input stream
    Throws:
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      2.0

  - ### toInputStream

    @Deprecated public static InputStream toInputStream(String input)
    Deprecated.
    2.5 use `toInputStream(String, Charset)` instead
    Converts the specified string to an input stream, encoded as bytes using the default character encoding of the platform.
    Parameters:
      `input` - the string to convert
    Returns:
      an input stream
    Since:
      1.1

  - ### toInputStream

    public static InputStream toInputStream(String input, Charset charset)
    Converts the specified string to an input stream, encoded as bytes using the specified character encoding.
    Parameters:
      `input` - the string to convert
      `charset` - the charset to use, null means platform default
    Returns:
      an input stream
    Since:
      2.3

  - ### toInputStream

    public static InputStream toInputStream(String input, String charsetName)
    Converts the specified string to an input stream, encoded as bytes using the specified character encoding.

    Character encoding names can be found at IANA.

    Parameters:
      `input` - the string to convert
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      an input stream
    Throws:
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### toString

    @Deprecated public static String toString(byte[] input)
    Deprecated.
    2.5 Use `String(byte[])` instead
    Gets the contents of a `byte[]` as a String using the default character encoding of the platform.
    Parameters:
      `input` - the byte array to read
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null

  - ### toString

    public static String toString(byte[] input, String charsetName)
    Gets the contents of a `byte[]` as a String using the specified character encoding.

    Character encoding names can be found at IANA.

    Parameters:
      `input` - the byte array to read
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null

  - ### toString

    @Deprecated public static String toString(InputStream input) throws IOException
    Deprecated.
    2.5 use `toString(InputStream, Charset)` instead
    Gets the contents of an `InputStream` as a String using the default character encoding of the platform.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs

  - ### toString

    public static String toString(InputStream input, Charset charset) throws IOException
    Gets the contents of an `InputStream` as a String using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read
      `charset` - the charset to use, null means platform default
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### toString

    public static String toString(InputStream input, String charsetName) throws IOException
    Gets the contents of an `InputStream` as a String using the specified character encoding.

    Character encoding names can be found at IANA.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - the `InputStream` to read
      `charsetName` - the name of the requested charset, null means platform default
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.

  - ### toString

    public static String toString(IOSupplier<InputStream> input, Charset charset) throws IOException
    Gets the contents of an `InputStream` from a supplier as a String using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - supplies the `InputStream` to read
      `charset` - the charset to use, null means platform default
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      2.12.0

  - ### toString

    public static String toString(IOSupplier<InputStream> input, Charset charset, IOSupplier<String> defaultString) throws IOException
    Gets the contents of an `InputStream` from a supplier as a String using the specified character encoding.

    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    Parameters:
      `input` - supplies the `InputStream` to read
      `charset` - the charset to use, null means platform default
      `defaultString` - the default return value if the supplier or its value is null.
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      2.12.0

  - ### toString

    public static String toString(Reader reader) throws IOException
    Gets the contents of a `Reader` as a String.

    This method buffers the input internally, so there is no need to use a `BufferedReader`.

    Parameters:
      `reader` - the `Reader` to read
    Returns:
      the requested String
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs

  - ### toString

    @Deprecated public static String toString(URI uri) throws IOException
    Deprecated.
    2.5 use `toString(URI, Charset)` instead
    Gets the contents at the given URI.
    Parameters:
      `uri` - The URI source.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
    Since:
      2.1

  - ### toString

    public static String toString(URI uri, Charset encoding) throws IOException
    Gets the contents at the given URI.
    Parameters:
      `uri` - The URI source.
      `encoding` - The encoding name for the URL contents.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
    Since:
      2.3.

  - ### toString

    public static String toString(URI uri, String charsetName) throws IOException
    Gets the contents at the given URI.
    Parameters:
      `uri` - The URI source.
      `charsetName` - The encoding name for the URL contents.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      2.1

  - ### toString

    @Deprecated public static String toString(URL url) throws IOException
    Deprecated.
    2.5 use `toString(URL, Charset)` instead
    Gets the contents at the given URL.
    Parameters:
      `url` - The URL source.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
    Since:
      2.1

  - ### toString

    public static String toString(URL url, Charset encoding) throws IOException
    Gets the contents at the given URL.
    Parameters:
      `url` - The URL source.
      `encoding` - The encoding name for the URL contents.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
    Since:
      2.3

  - ### toString

    public static String toString(URL url, String charsetName) throws IOException
    Gets the contents at the given URL.
    Parameters:
      `url` - The URL source.
      `charsetName` - The encoding name for the URL contents.
    Returns:
      The contents of the URL as a String.
    Throws:
      `IOException` - if an I/O exception occurs.
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      2.1

  - ### write

    public static void write(byte[] data, OutputStream output) throws IOException
    Writes bytes from a `byte[]` to an `OutputStream`.
    Parameters:
      `data` - the byte array to write, do not modify during output, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    @Deprecated public static void write(byte[] data, Writer writer) throws IOException
    Deprecated.
    2.5 use `write(byte[], Writer, Charset)` instead
    Writes bytes from a `byte[]` to chars on a `Writer` using the default character encoding of the platform.

    This method uses `String(byte[])`.

    Parameters:
      `data` - the byte array to write, do not modify during output, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    public static void write(byte[] data, Writer writer, Charset charset) throws IOException
    Writes bytes from a `byte[]` to chars on a `Writer` using the specified character encoding.

    This method uses `String(byte[], String)`.

    Parameters:
      `data` - the byte array to write, do not modify during output, null ignored
      `writer` - the `Writer` to write to
      `charset` - the charset to use, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### write

    public static void write(byte[] data, Writer writer, String charsetName) throws IOException
    Writes bytes from a `byte[]` to chars on a `Writer` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method uses `String(byte[], String)`.

    Parameters:
      `data` - the byte array to write, do not modify during output, null ignored
      `writer` - the `Writer` to write to
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### write

    @Deprecated public static void write(char[] data, OutputStream output) throws IOException
    Deprecated.
    2.5 use `write(char[], OutputStream, Charset)` instead
    Writes chars from a `char[]` to bytes on an `OutputStream`.

    This method uses `String(char[])` and `String.getBytes()`.

    Parameters:
      `data` - the char array to write, do not modify during output, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    public static void write(char[] data, OutputStream output, Charset charset) throws IOException
    Writes chars from a `char[]` to bytes on an `OutputStream` using the specified character encoding.

    This method uses `String(char[])` and `String.getBytes(String)`.

    Parameters:
      `data` - the char array to write, do not modify during output, null ignored
      `output` - the `OutputStream` to write to
      `charset` - the charset to use, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### write

    public static void write(char[] data, OutputStream output, String charsetName) throws IOException
    Writes chars from a `char[]` to bytes on an `OutputStream` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method uses `String(char[])` and `String.getBytes(String)`.

    Parameters:
      `data` - the char array to write, do not modify during output, null ignored
      `output` - the `OutputStream` to write to
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### write

    public static void write(char[] data, Writer writer) throws IOException
    Writes chars from a `char[]` to a `Writer`
    Parameters:
      `data` - the char array to write, do not modify during output, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    @Deprecated public static void write(CharSequence data, OutputStream output) throws IOException
    Deprecated.
    2.5 use `write(CharSequence, OutputStream, Charset)` instead
    Writes chars from a `CharSequence` to bytes on an `OutputStream` using the default character encoding of the platform.

    This method uses `String.getBytes()`.

    Parameters:
      `data` - the `CharSequence` to write, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.0

  - ### write

    public static void write(CharSequence data, OutputStream output, Charset charset) throws IOException
    Writes chars from a `CharSequence` to bytes on an `OutputStream` using the specified character encoding.

    This method uses `String.getBytes(String)`.

    Parameters:
      `data` - the `CharSequence` to write, null ignored
      `output` - the `OutputStream` to write to
      `charset` - the charset to use, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### write

    public static void write(CharSequence data, OutputStream output, String charsetName) throws IOException
    Writes chars from a `CharSequence` to bytes on an `OutputStream` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method uses `String.getBytes(String)`.

    Parameters:
      `data` - the `CharSequence` to write, null ignored
      `output` - the `OutputStream` to write to
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      2.0

  - ### write

    public static void write(CharSequence data, Writer writer) throws IOException
    Writes chars from a `CharSequence` to a `Writer`.
    Parameters:
      `data` - the `CharSequence` to write, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.0

  - ### write

    @Deprecated public static void write(String data, OutputStream output) throws IOException
    Deprecated.
    2.5 use `write(String, OutputStream, Charset)` instead
    Writes chars from a `String` to bytes on an `OutputStream` using the default character encoding of the platform.

    This method uses `String.getBytes()`.

    Parameters:
      `data` - the `String` to write, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    public static void write(String data, OutputStream output, Charset charset) throws IOException
    Writes chars from a `String` to bytes on an `OutputStream` using the specified character encoding.

    This method uses `String.getBytes(String)`.

    Parameters:
      `data` - the `String` to write, null ignored
      `output` - the `OutputStream` to write to
      `charset` - the charset to use, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### write

    public static void write(String data, OutputStream output, String charsetName) throws IOException
    Writes chars from a `String` to bytes on an `OutputStream` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method uses `String.getBytes(String)`.

    Parameters:
      `data` - the `String` to write, null ignored
      `output` - the `OutputStream` to write to
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### write

    public static void write(String data, Writer writer) throws IOException
    Writes chars from a `String` to a `Writer`.
    Parameters:
      `data` - the `String` to write, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    @Deprecated public static void write(StringBuffer data, OutputStream output) throws IOException
    Deprecated.
    Use `write(CharSequence, OutputStream)`
    Writes chars from a `StringBuffer` to bytes on an `OutputStream` using the default character encoding of the platform.

    This method uses `String.getBytes()`.

    Parameters:
      `data` - the `StringBuffer` to write, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### write

    @Deprecated public static void write(StringBuffer data, OutputStream output, String charsetName) throws IOException
    Deprecated.
    Use `write(CharSequence, OutputStream, String)`.
    Writes chars from a `StringBuffer` to bytes on an `OutputStream` using the specified character encoding.

    Character encoding names can be found at IANA.

    This method uses `String.getBytes(String)`.

    Parameters:
      `data` - the `StringBuffer` to write, null ignored
      `output` - the `OutputStream` to write to
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### write

    @Deprecated public static void write(StringBuffer data, Writer writer) throws IOException
    Deprecated.
    Use `write(CharSequence, Writer)`
    Writes chars from a `StringBuffer` to a `Writer`.
    Parameters:
      `data` - the `StringBuffer` to write, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### writeChunked

    public static void writeChunked(byte[] data, OutputStream output) throws IOException
    Writes bytes from a `byte[]` to an `OutputStream` using chunked writes. This is intended for writing very large byte arrays which might otherwise cause excessive memory usage if the native code has to allocate a copy.
    Parameters:
      `data` - the byte array to write, do not modify during output, null ignored
      `output` - the `OutputStream` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.5

  - ### writeChunked

    public static void writeChunked(char[] data, Writer writer) throws IOException
    Writes chars from a `char[]` to a `Writer` using chunked writes. This is intended for writing very large byte arrays which might otherwise cause excessive memory usage if the native code has to allocate a copy.
    Parameters:
      `data` - the char array to write, do not modify during output, null ignored
      `writer` - the `Writer` to write to
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.5

  - ### writeLines

    @Deprecated public static void writeLines(Collection<?> lines, String lineEnding, OutputStream output) throws IOException
    Deprecated.
    2.5 use `writeLines(Collection, String, OutputStream, Charset)` instead
    Writes the `Object.toString()` value of each item in a collection to an `OutputStream` line by line, using the default character encoding of the platform and the specified line ending.
    Parameters:
      `lines` - the lines to write, null entries produce blank lines
      `lineEnding` - the line separator to use, null is system default
      `output` - the `OutputStream` to write to, not null, not closed
    Throws:
      `NullPointerException` - if the output is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### writeLines

    public static void writeLines(Collection<?> lines, String lineEnding, OutputStream output, Charset charset) throws IOException
    Writes the `Object.toString()` value of each item in a collection to an `OutputStream` line by line, using the specified character encoding and the specified line ending.

    UTF-16 is written big-endian with no byte order mark. For little endian, use UTF-16LE. For a BOM, write it to the stream before calling this method.

    Parameters:
      `lines` - the lines to write, null entries produce blank lines
      `lineEnding` - the line separator to use, null is system default
      `output` - the `OutputStream` to write to, not null, not closed
      `charset` - the charset to use, null means platform default
    Throws:
      `NullPointerException` - if output is null
      `IOException` - if an I/O error occurs
    Since:
      2.3

  - ### writeLines

    public static void writeLines(Collection<?> lines, String lineEnding, OutputStream output, String charsetName) throws IOException
    Writes the `Object.toString()` value of each item in a collection to an `OutputStream` line by line, using the specified character encoding and the specified line ending.

    Character encoding names can be found at IANA.

    Parameters:
      `lines` - the lines to write, null entries produce blank lines
      `lineEnding` - the line separator to use, null is system default
      `output` - the `OutputStream` to write to, not null, not closed
      `charsetName` - the name of the requested charset, null means platform default
    Throws:
      `NullPointerException` - if the output is null
      `IOException` - if an I/O error occurs
      `UnsupportedCharsetException` - thrown instead of `.UnsupportedEncodingException` in version 2.2 if the encoding is not supported.
    Since:
      1.1

  - ### writeLines

    public static void writeLines(Collection<?> lines, String lineEnding, Writer writer) throws IOException
    Writes the `Object.toString()` value of each item in a collection to a `Writer` line by line, using the specified line ending.
    Parameters:
      `lines` - the lines to write, null entries produce blank lines
      `lineEnding` - the line separator to use, null is system default
      `writer` - the `Writer` to write to, not null, not closed
    Throws:
      `NullPointerException` - if the input is null
      `IOException` - if an I/O error occurs
    Since:
      1.1

  - ### writer

    public static Writer writer(Appendable appendable)
    Returns the given Appendable if it is already a `Writer`, otherwise creates a Writer wrapper around the given Appendable.
    Parameters:
      `appendable` - the Appendable to wrap or return (not null)
    Returns:
      the given Appendable or a Writer wrapper around the given Appendable
    Throws:
      `NullPointerException` - if the input parameter is null
    Since:
      2.7